/**********************************************************************/
/** Copyright (C) 2021 - Université Catholique de Louvain		**/
/** affinistan version 2021.1						**/
/** Author: Mohamed HADDAD (immc-MEMA)				**/
/** Contact: mohamed.haddad@uclouvain.be				**/
/** Use of this source code is governed by an UCL-style license	**/ 
/** All Rights Reserved						**/
/** This project has received funding from the European 		**/
/** Union’s Horizon 2020 research and innovation program		**/
/** under grant agreement No 862015					**/
/***********************************************************************/

#ifndef MATPROP_H
#define MATPROP_H 1


typedef struct Matprop
{ 

  char behavior[10];		/** material behavior				**/      
  double young;		/** E0 at t=0					**/  
  double nu;			/** Poisson's ratio				**/  
  double yldstrs;	 	/** initial yield stress			**/  
  
  int hardmodel;		/** Hardening model parameters		**/  
  double hardmodulus;
  double hardexp;
  
  int viscmodel;		/** VP model parameters			**/ 
  double visccoef;
  double viscexp1;
  double viscexp2;
  
  double v;			/** volume fraction				**/ 
  double ar;			/** aspect ratio				**/ 
  double orient[3];		/** inclusions' orientation			**/ 

  /** VE properties-Prony series	**/ 
  /**************************************/
  
  int nbrGi;  			/** number of shear relaxation weights & times**/
  double *Gi; 			/** shear relaxation weights			**/ 
  double *gi; 			/** shear relaxation times			**/

  int nbrKj;   		/** number of bulk relaxation weights & times	**/ 
  double *Kj;  		/** bulk relaxation weights 			**/
  double *skj; 		/** bulk relaxation times 			**/ 
 

}MATPROP;

#endif
