# UMATs for various constitutive models

[![License: CC BY 4.0](https://img.shields.io/badge/License-CC_BY_4.0-lightgrey.svg)](https://creativecommons.org/licenses/by/4.0/)
[![MOAMMM](https://img.shields.io/badge/MOAMMM-2ea44f?logo=gitlab)](https://gitlab.uliege.be/moammm/moammmPublic)

* Material models are arranged inside the repository by small and finite strain implementations.

* Sample job files for ABAQUS (.inp) are included, which will assist in material parameter defination.

## MOAMMM related constitutive law

**Viscoelastic - Viscoplastic (VEVP)  [^1]** ,  is the relavent material law for the MOAMMM project. UMAT & details for material parameters are  located under:

>[FiniteStrain/Finite_VEVP](FiniteStrain/Finite_VEVP)  
>[SmallStrain/SS_VEVPD](SmallStrain/SS_VEVPD)

## Disclaimer

Code related to MOAMMM project
This project has received funding from the European Union’s Horizon 2020 research and innovation programme under grant agreement No 862015.

Views and opinions expressed are however those of the author(s) only and do not necessarily reflect those of the European Union. Neither
the European Union nor the granting authority can be held responsible for them.

[^1]: The finite-strain visco-elastic visco-plastic model follows:  
"_Nguyen, V. D., Lani, F., Pardoen, T., Morelle, X., & Noels, L. (01 October 2016)._ **A large strain hyperelastic viscoelastic-viscoplastic-damage constitutive model based on a multi-mechanism non-local damage continuum for amorphous glassy polymers.** International Journal of Solids and Structures, 96, 192-216.  [doi:10.1016/j.ijsolstr.2016.06.008](doi:10.1016/j.ijsolstr.2016.06.008)" which can be downloaded [here](https://hdl.handle.net/2268/197898).  
we would be grateful if you could cite this publication in case you use the files